RMS.LoadLibrary("rmgen");
InitMap();

setBiome(2);
initMapSettings();
initTileClasses();

RMS.SetProgress(10);

resetTerrain(g_Terrains.mainTerrain, g_TileClasses.land, 2);

// Create normal lake
var placer = new ClumpPlacer(g_MapInfo.mapArea * 0.02, 1, 1, 1, g_MapInfo.centerOfMap, g_MapInfo.centerOfMap);
var terrainPainter = new LayeredPainter([g_Terrains.water, g_Terrains.water], [2]);
var elevationPainter = new SmoothElevationPainter(ELEVATION_SET, -5, 2);
createArea(placer, [terrainPainter, elevationPainter, paintClass(g_TileClasses.water)]);

// Create mound
var placer = new ClumpPlacer(g_MapInfo.mapArea * 0.05, 1, 1, 1, g_MapInfo.centerOfMap * 0.6, g_MapInfo.centerOfMap * 0.6);
var terrainPainter = new LayeredPainter([g_Terrains.cliff, g_Terrains.mainTerrain], [2]);
var elevationPainter = new SmoothElevationPainter(ELEVATION_SET, 10, 2);
createArea(placer, [terrainPainter, elevationPainter, paintClass(g_TileClasses.water)]);

// Should create a lake on top of the mound, but fails
var placer = new ClumpPlacer(g_MapInfo.mapArea * 0.02, 1, 1, 1, g_MapInfo.centerOfMap * 0.6, g_MapInfo.centerOfMap * 0.6);
var terrainPainter = new LayeredPainter([g_Terrains.water, g_Terrains.water], [2]);
var elevationPainter = new SmoothElevationPainter(ELEVATION_SET, 7, 2);
createArea(placer, [terrainPainter, elevationPainter, paintClass(g_TileClasses.water)]);

// Should create a below sea-level valley, but fails
var placer = new ClumpPlacer(g_MapInfo.mapArea * 0.02, 1, 1, 1, g_MapInfo.centerOfMap * 1.4, g_MapInfo.centerOfMap * 1.4);
var terrainPainter = new LayeredPainter([g_Terrains.mainTerrain, g_Terrains.dirt], [2]);
var elevationPainter = new SmoothElevationPainter(ELEVATION_SET, -5, 2);
createArea(placer, [terrainPainter, elevationPainter, paintClass(g_TileClasses.valley)]);

RMS.SetProgress(90);

ExportMap();
